// Construction program
structsTyp = {
    fact: ["A0LightFactory", "base"],
    lab: ["A0ResearchFacility", "base"],
    gen: ["A0PowerGenerator", "base"],
    hq: ["A0CommandCentre", "base"],
    basicdef: ["GuardTower1", "base"],
    cybfact: ["A0CyborgFactory", "base"],
    rpfac: ["A0RepairCentre3", "base"],
    vtolfact: ["A0VTolFactory1", "base"],
    vtolpad: ["A0VtolPad", "base"],
    derrick: ["A0ResourceExtractor", "derrick"],
};

// droid.busy does not work. so we use this instead.
function truckIdle(truck) {
    if (truck.droidType != DROID_CONSTRUCT)
		return false;
    if (truck.order == DORDER_BUILD)
		return false;
    if (truck.order == DORDER_HELPBUILD)
		return false;
    if (truck.order == DORDER_LINEBUILD)
		return false;
    if (truck.order == DORDER_DEMOLISH)
		return false;
    return true;
}

// Build base structs functions
function build(struct) {
    engineerre = enumDroid(me, DROID_CONSTRUCT);
    var i;
    for (i = 0; i < engineerre.length; i++) {
        if (truckIdle(engineerre[i])) {
            if (struct[1] == "base") {
                structLoc = pickStructLocation(engineerre[i], struct[0],
                                           engineerre[i].x + randomNum(8) - 4,
                                           engineerre[i].y + randomNum(8) - 4);
                orderDroidBuild(engineerre[i], DORDER_BUILD, struct[0], structLoc.x, structLoc.y);
            } else if (struct[1] == "derrick") {
                getOil();
            }
            break;
        }
    }
}

function buildBase() {
    if (enumStruct(me, FACTORY).length == 0) {
        build(structsTyp.fact);
    } else if (enumStruct(me, RESEARCH_LAB).length == 0) {
        build(structsTyp.lab);
    } else if (enumStruct(me, HQ).length == 0) {
        build(structsTyp.hq);
    } else if (enumStruct(me, DEFENSE).length < 5 && gameTime < 300000 && getMultiTechLevel() <= 1) {
        build(structsTyp.basicdef);
    } else if (enumStruct(me, RESOURCE_EXTRACTOR).length < 4) {
        build(structsTyp.derrick);
    }
}

function buildExtra(num) {
    if (enumStruct(me, FACTORY).length < num) {
        build(structsTyp.fact);
    } else if (enumStruct(me, RESEARCH_LAB).length < num) {
        build(structsTyp.lab);
    } else if (enumStruct(me, CYBORG_FACTORY).length < num) {
        build(structsTyp.cybfact);
    } else if (enumStruct(me, REPAIR_FACILITY).length < num) {
        build(structsTyp.rpfac);
    } else if (enumStruct(me, VTOL_FACTORY).length < num) {
        build(structsTyp.vtolfact);
    } else if (enumStruct(me, REARM_PAD).length < num * 5) {
        build(structsTyp.vtolpad);
    }
}

function buildExtras() {
    subtractor = baseType * 100000
    if (playerPower(me) > 100) {
        buildExtra(1);
    }
    if (gameTime > 200000 - subtractor && playerPower(me) > 400) {
        buildExtra(2);
    }
    if (gameTime > 350000 - subtractor && playerPower(me) > 600) {
        buildExtra(3);
    }
    if (gameTime > 500000 - subtractor && playerPower(me) > 800) {
        buildExtra(4);
    }
    if (gameTime > 750000 - subtractor && playerPower(me) > 1500) {
        buildExtra(5);
    }
}

// Leave no derricks unused!
function checkGen() {
    if (enumStruct(me, POWER_GEN).length * 4
        < enumStruct(me, RESOURCE_EXTRACTOR).length) {
        build(structsTyp.gen);
    }
}

var needModStructs;
var maxmods;
function checkMod() {
    needModStructs = enumStruct(me, POWER_GEN).concat(enumStruct(me, RESEARCH_LAB)).concat(enumStruct(me, FACTORY)).concat(enumStruct(me, VTOL_FACTORY));
    var i;
    var y;
    var modTyp;
    for (i = 0; i < needModStructs.length; i++) {
        switch(needModStructs[i].stattype) {
            case FACTORY:
            case VTOL_FACTORY:
                maxmods = 2;
                break;
            default:
                maxmods = 1;
                break;
        }
        if (needModStructs[i].modules < maxmods) {
            debug_("Structure " + needModStructs[i] + " needs modules");
            if (needModStructs[i].stattype == FACTORY) {
                modTyp = "A0FacMod1";
            } else if (needModStructs[i].stattype == RESEARCH_LAB) {
                modTyp = "A0ResearchModule1";
            } else if (needModStructs[i].stattype == POWER_GEN) {
                modTyp = "A0PowMod1";
            }
            engineerre = enumDroid(me, DROID_CONSTRUCT);
            if (truckIdle(engineerre[0])) {
                orderDroidBuild(engineerre[0], DORDER_BUILD, modTyp, needModStructs[i].x, needModStructs[i].y);
            }
            return;
        }
    }
}

// "oiling" function
var dists = [];
var resourc;
function getOil() {
    engineerre = enumDroid(me, DROID_CONSTRUCT);
    resourc = enumFeature(ALL_PLAYERS, "OilResource");
    debug_("Current resources: " + resourc);
    var i;
    var y;
    var n;
    for (i = 0; i < engineerre.length; i++) {
        if (truckIdle(engineerre[i])) {
            var y;
            for (y = 0; y < resourc.length; y++) {
                dists[y] = [distBetweenTwoPoints(engineerre[i].x, engineerre[i].y, resourc[y].x, resourc[y].y), resourc[y]];
            }
            dists = sortLi2(dists);
            randmax = (resourc.length < 6) ? 1 : 3;
            randand = randomNum(randmax) + 1;
            orderDroidBuild(engineerre[i], DORDER_BUILD, "A0ResourceExtractor", dists[randand][1].x, dists[randand][1].y);
            armies = enumGroup(groups.spamborgs);
            for (n = 0; n < armies.length; n++) {
                orderDroidLoc(armies[n], DORDER_SCOUT, dists[randand][1].x, dists[randand][1].y);
            }
            break;
        }
    }
}
